﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace DropDownResize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_AfterColPosChanged(object sender, Infragistics.Win.UltraWinGrid.AfterColPosChangedEventArgs e)
        {
            SetDropDownWidth();
        }

        private void SetDropDownWidth()
        {
            int widthColumns = 0;
            foreach (UltraGridColumn col in ultraGrid1.DisplayLayout.Bands[0].Columns)
                if (!col.Hidden)
                {
                    widthColumns += col.Width;
                    Console.WriteLine(col.Width);
                }
            int totalWidth = widthColumns + SystemInformation.VerticalScrollBarWidth + 2;
            ultraGrid1.Width = totalWidth;

            (ultraTextEditor1.ButtonsRight[0] as DropDownEditorButton).PreferredDropDownSize = new Size(totalWidth, ultraGrid1.Height);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable tb = new DataTable();
            tb.Columns.Add("Column1");
            tb.Columns.Add("Column2");
            tb.Columns.Add("Column3");
            tb.Rows.Add("1234567", "1234567", "1234567");
            tb.Rows.Add("abcdefgh", "abcdefgh", "abcdefgh");

            ultraGrid1.DataSource = tb;
        }

        private void ultraTextEditor1_BeforeEditorButtonDropDown(object sender, BeforeEditorButtonDropDownEventArgs e)
        {
            SetDropDownWidth();
        }
    }
}
